﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BR.AN.PviServices;
using System.Windows.Forms;


namespace ConsoleApplication2
{
    class Program
    {
        static Service service;
        static Cpu cpu;
        static Variable variable;

        static int MaxInterval = 0;
        static int MinInterval = 1000;
        static int AvgInterval = 0;
        static int CalInterval = 0;
        static int LastValue = 0;
        static int Count = 0;
        
        [STAThread]
        static void Main(string[] args)
        {

            Console.WriteLine("Connecting Service ...");
            service = new Service("Service");
            service.Error += new PviEventHandler(Error);
            service.Connected += new PviEventHandler(service_Connected);
            service.Connect();

            // Message loop
            Application.Run();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        static void service_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Service Connected Error=" + e.ErrorCode.ToString());
            cpu = new Cpu(service, "Cpu");

            cpu.Connection.DeviceType = DeviceType.ANSLTcp;
            //cpu.Connection.ANSLTcp.DestinationIpAddress = "127.0.0.1";
            cpu.Connection.ANSLTcp.DestinationIpAddress = "192.168.10.10";

            //cpu.Connection.DeviceType = DeviceType.TcpIp;
            //cpu.Connection.TcpIp.DestinationIpAddress = "127.0.0.1";
            //cpu.Connection.TcpIp.DestinationPort = 11160;
            //cpu.Connection.TcpIp.ResponseTimeout = 2000;

            cpu.Connected += new PviEventHandler(cpu_Connected);
            cpu.DateTimeRead += new CpuEventHandler(cpu_DateTimeRead);

            Console.WriteLine("Connecting Cpu ...");
            cpu.Connect();
        }

        static void cpu_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Cpu Connected Error=" + e.ErrorCode.ToString());
            
            cpu.ReadDateTime();
            variable = new Variable(cpu, "Var_St2.a");
            //variable.Active = true;
            //variable.RefreshTime = 1000;
            //variable.Polling = false;
            //variable.ValueChanged += new VariableEventHandler(ValueChanged);
            //variable.Connected += new PviEventHandler(variable_Connected);
            //Console.WriteLine("Connecting Variable ...");
            //variable.Connect();
            //Console.WriteLine("Connecting Var done ...");

            variable.ValueRead += new PviEventHandler(variable_ValueRead);
            variable.Connected += new PviEventHandler(variable_Connected);
            variable.ExpandMembers = true;
            variable.Connect();
        }

        static void variable_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Variable Connected Error=" + e.ErrorCode.ToString());
            
            Console.WriteLine("Connecting Variable ...");
            variable.ReadValueEx();
            Console.WriteLine("After variable.ReadValue();");
        }

        /// <summary>
        /// Exit application if an error occurs
        /// </summary>
        static void Error(object sender, PviEventArgs e)
        {
            Console.WriteLine(String.Format("Error:{0}", e.ErrorText));
            //Application.Exit();
        }

        /// <summary>
        /// Write variable value to the console
        /// </summary>
        static void ValueChanged(object sender, VariableEventArgs e)
        {
            Variable var = (Variable)sender;
            Console.WriteLine(DateTime.Now.ToString("yyyy - MM - dd hh: mm:ss.fff") + ":  " + "Value={0}", var.Value.ToString());
            //Application.Exit();
        }

        static void cpu_DateTimeRead(object sender, CpuEventArgs e)
        {
            Console.WriteLine("CPU DATE: " +"Value = {0}", e.DateTime.ToString());
        }

        static void variable_ValueRead(object sender, PviEventArgs e)
        {
            //Console.WriteLine("Step into variable_ValueRead");
            Variable tmpVariable = (Variable)sender;
            //Console.WriteLine("Var Name: " + tmpVariable.Value.ToString());
            //Console.WriteLine("变量信息：" + tmpVariable.Value[0].ToString());

            CalInterval = Math.Abs((int)tmpVariable.Value[0] - LastValue);

            //判断有无最大偏差值
            bool result = (CalInterval > MaxInterval) && (CalInterval < 1000);
            if (result == true)
            {
                MaxInterval = CalInterval;
            }

            //判断有无最小偏差值
            result = (CalInterval < MinInterval) && (CalInterval > 0);
            if (result == true)
            {
                MinInterval = CalInterval;
            }

            //统计平均值
            result = (CalInterval > 0) && (CalInterval < 1000);
            if (result)
            {
                AvgInterval = (AvgInterval + CalInterval) / 2;
            }

            LastValue = (int)tmpVariable.Value[0];

            Count++;
            if (Count > 100)
            {
                Count = 0;
                Console.WriteLine(" 当前通信延时最大值 {0}；最小值为{1}；平均值为{2} ", MaxInterval, MinInterval, AvgInterval);
            }

            // 等待时间，可以通过此参数调整采样频率，以确认不同刷新频率下，对CPU负载影响情况
            //System.Threading.Thread.Sleep(1000);//单位为ms

            variable.ReadValueEx();

        }
    }
}
